import { jsxs as _jsxs } from "react/jsx-runtime";
import { jsx as _jsx } from "react/jsx-runtime";
import PropTypes from 'prop-types';
import cx from 'classnames';
import SpinnerBasic from '@s-ui/react-spinner-basic';
import { useNearScreen } from '@s-ui/react-hooks';
var BASE_CLASS = 'sui-ImageLazyLoad';
var BASE_CLASS_IMAGE = BASE_CLASS + "-image";
var BASE_CLASS_IMAGE_WRAP = BASE_CLASS + "-imageWrap";
export var FIT_MODES = {
  contain: 'contain',
  cover: 'cover',
  "default": 'default',
  fill: 'fill',
  none: 'none'
};
/**
 * Component that will print defer loading images with an optional and specific
 * aspect ratio.
 */

export default function ImageLazyLoad(_ref) {
  var _cx, _cx2, _cx3;

  var _ref$alt = _ref.alt,
      alt = _ref$alt === void 0 ? '' : _ref$alt,
      _ref$aspectRatio = _ref.aspectRatio,
      aspectRatio = _ref$aspectRatio === void 0 ? '' : _ref$aspectRatio,
      _ref$fitMode = _ref.fitMode,
      fitMode = _ref$fitMode === void 0 ? FIT_MODES["default"] : _ref$fitMode,
      _ref$offsetVertical = _ref.offsetVertical,
      offsetVertical = _ref$offsetVertical === void 0 ? 100 : _ref$offsetVertical,
      _ref$onError = _ref.onError,
      onError = _ref$onError === void 0 ? function () {} : _ref$onError,
      _ref$showSpinner = _ref.showSpinner,
      showSpinner = _ref$showSpinner === void 0 ? true : _ref$showSpinner,
      src = _ref.src,
      _ref$title = _ref.title,
      title = _ref$title === void 0 ? '' : _ref$title;

  var _useNearScreen = useNearScreen({
    offset: offsetVertical + "px"
  }),
      isNearScreen = _useNearScreen[0],
      fromRef = _useNearScreen[1];

  var lazyLoadWrapClassName = cx(BASE_CLASS, (_cx = {}, _cx[BASE_CLASS + "--ratio-" + aspectRatio.replace(':', '-')] = aspectRatio, _cx[BASE_CLASS + "--fitContain"] = fitMode === FIT_MODES.contain, _cx[BASE_CLASS + "--fitCover"] = fitMode === FIT_MODES.cover, _cx[BASE_CLASS + "--fitFill"] = fitMode === FIT_MODES.fill, _cx[BASE_CLASS + "--fitNone"] = fitMode === FIT_MODES.none, _cx));
  var lazyLoadImageClassName = cx(BASE_CLASS_IMAGE, (_cx2 = {}, _cx2[BASE_CLASS_IMAGE + "--fitContain"] = fitMode === FIT_MODES.contain, _cx2[BASE_CLASS_IMAGE + "--fitCover"] = fitMode === FIT_MODES.cover, _cx2[BASE_CLASS_IMAGE + "--fitFill"] = fitMode === FIT_MODES.fill, _cx2[BASE_CLASS_IMAGE + "--fitNone"] = fitMode === FIT_MODES.none, _cx2));
  var lazyLoadImageWrapClassName = cx(BASE_CLASS_IMAGE_WRAP, (_cx3 = {}, _cx3[BASE_CLASS_IMAGE_WRAP + "--fitContain"] = fitMode === FIT_MODES.contain, _cx3[BASE_CLASS_IMAGE_WRAP + "--fitCover"] = fitMode === FIT_MODES.cover, _cx3[BASE_CLASS_IMAGE_WRAP + "--fitFill"] = fitMode === FIT_MODES.fill, _cx3[BASE_CLASS_IMAGE_WRAP + "--fitNone"] = fitMode === FIT_MODES.none, _cx3));
  return /*#__PURE__*/_jsxs("div", {
    className: lazyLoadWrapClassName,
    ref: fromRef,
    children: [!isNearScreen && showSpinner && /*#__PURE__*/_jsx("div", {
      className: BASE_CLASS + "-spinner",
      children: /*#__PURE__*/_jsx(SpinnerBasic, {})
    }), /*#__PURE__*/_jsx("div", {
      className: lazyLoadImageWrapClassName,
      children: isNearScreen && /*#__PURE__*/_jsx("img", {
        alt: alt,
        className: lazyLoadImageClassName,
        onError: onError,
        src: src,
        title: title
      })
    })]
  });
}
ImageLazyLoad.displayName = 'ImageLazyLoad';